var KmlBrowserLight = {
	IS_IE:false
	,
	COOKIE_HEADER:false
	,
	MAP_ID:false
	,
	getCookie:function(key) {
		if (!KmlBrowserLight.COOKIE_HEADER) return false;
		return KmlBrowserLight.cookieManager.getCookie(KmlBrowserLight.COOKIE_HEADER + "-" + key);
	}
	,
	setCookie:function(key, value) {
		if (!KmlBrowserLight.COOKIE_HEADER) return;
		KmlBrowserLight.cookieManager.setCookie(KmlBrowserLight.COOKIE_HEADER + "-" + key, value);
	}
	,
	DEFAULT_ZOOM_LEVEL:10
	,
	DEFAULT_LAT_LNG:new google.maps.LatLng(35.73945945860445, 140.26754760742185)
	,
	DEBUG_MODE:true
	,
	DEBUG_LOGGER:false
	,
	showMessage: function(str) {
		var txt = str.escapeHTML();
		KmlBrowserLight.messageWindow.innerHTML = txt.replace(/\n/g,"<br>");
	    var cStyle = KmlBrowserLight.messageWindow.currentStyle || document.defaultView.getComputedStyle(KmlBrowserLight.messageWindow, '');
	    if (cStyle.display == "none") {
	    	var clientSize = KmlBrowserLight.getClientSize();
	    	KmlBrowserLight.messageWindow.style.top = (clientSize.height / 2 - 40) + "px";
	    	KmlBrowserLight.messageWindow.style.left = (clientSize.width / 2 - 150) + "px";
	    	KmlBrowserLight.messageWindow.style.width = "300px";
	    	KmlBrowserLight.messageWindow.style.height = "80px";
			KmlBrowserLight.messageWindow.style.opacity = "0.0";
			KmlBrowserLight.messageWindow.style["-moz-opcity"] = "0.0";
			KmlBrowserLight.messageWindow.style.filter = "alpha(opacity=0)";
			KmlBrowserLight.messageWindow.style.display = "block";
		    new Effect.Opacity("message", { from : 0, to : 1.0, duration : 0.5 } );
		}
	}
	,
	hideMessage: function() {
	    var cStyle = KmlBrowserLight.messageWindow.currentStyle || document.defaultView.getComputedStyle(KmlBrowserLight.messageWindow, '');
	    if (cStyle.display != "none") {
	    	new Effect.Opacity("message", {from : 1.0, to : 0.0, duration: 1.5, afterFinish:function() {
	    		KmlBrowserLight.messageWindow.style.display = "none";
	    	}});
	    }
		
	}
	,
	DescriptionPane:function(container, header, body) {
		this.containerName = container;
		this.headerName    = header;
		this.bodyName     = body;
		this.divContainer = $(container);
		this.divHeader    = $(header);
		this.divBody      = $(body);
		this.resize();
        Event.observe(this.headerName, "click", this.toggleContent, false);
	}
	,
	onLoad:function() {
        var js = /kmlBrowserLight\.js(\?.*)?$/;
        $$('script[src]').findAll(function(s) {
            return s.src.match(js);
        }).each(function(s) {
            var path = s.src.replace(js, '');
            var options = s.src.match(/\?(\S*)/);
            (options ? options[1] : "").split(",").each(
            function(option) { 
            	var keyVal = option.split("=");
            	if (keyVal.length > 0) {
            		var val = "";
            		var key = keyVal[0];
            		if (keyVal.length > 1) val = keyVal[1];
            		if (key.toLowerCase() == "mapid") {
            			KmlBrowserLight.MAP_ID = val;
            			var ix = val.indexOf(".");
            			if (ix > -1) {
            				KmlBrowserLight.COOKIE_HEADER = val.substring(ix + 1);
            			}
            		}
            	} 
            });
        
        
        });
		
		var body = document.getElementsByTagName("body")[0];
		var divMap = new Element("div", {id:"map_canvas"});
		$(body).insert(divMap);
		
		var spanDescText = new Element("span", {id:"descriptionText"});
		var divDescBody  = new Element("div", {id:"descriptionBody"});
		$(divDescBody).insert(spanDescText);
		var divDescTitle = new Element("div", {id:"descriptionTitle"});
		var divDesc = new Element("div", {id:"description"});
		$(divDesc).insert(divDescTitle);
		$(divDesc).insert(divDescBody);
		$(body).insert(divDesc);
		
	    var divMsg =  new Element("div", {id:"message"});@
	    $(body).insert(divMsg);
	    /*
	var row =  new Element("tr", {});
	var col1 = new Element("td", {className:"indexColumn"});
	var col2 = new Element("td", {className:"indexColumn"});
	var col2Div1 = new Element("div", {className:"indexHeader"});
	var col2Div2 = new Element("div", {className:"indexContent"});
	col1.insert(img);
		*/
		
		// oGtFNg̏
		var clienzSize = KmlBrowserLight.getClientSize();
		KmlBrowserLight.messageWindow = $("message");
		KmlBrowserLight.controller = new KmlBrowserLight.DescriptionPane("description", "descriptionTitle", "descriptionBody");
		
		
		
        if (!KmlBrowserLight.MAP_ID) {
		    KmlBrowserLight.showMessage("}bvIDw肳Ă܂B\nݒĂ݂ĂB");
        	return;
        }
		
		
		
		
		
		var initLat = KmlBrowserLight.getCookie("lat");
        var initLatLng = KmlBrowserLight.DEFAULT_LAT_LNG;
        if (initLat) {
        	var initLng = KmlBrowserLight.getCookie("lng");
        	if (initLng) {
        		initLatLng = new google.maps.LatLng(initLat, initLng);
        	} 
        }
        
        var initZoom = KmlBrowserLight.DEFAULT_ZOOM_LEVEL;
        var _initZoom = KmlBrowserLight.getCookie("zoom");
        if (_initZoom) initZoom = parseInt(_initZoom, 10);
        
        var initTerrain = google.maps.MapTypeId.ROADMAP;
        // if (cookieManager.getCookie("terrain") == "0") initTerrain = google.maps.MapTypeId.ROADMAP;
        // $(GMap.MAP_TYPE_CHECK_BOX).checked = (initTerrain == google.maps.MapTypeId.TERRAIN);
       //  $("chkShowValue").checked = (cookieManager.getCookie("label") == "1");
        // ȉA{
        var mapOptions = {
            zoom: initZoom,
            center: initLatLng,
            disableDefaultUI:true,
            mapTypeId: initTerrain,
            navigationControl: true,
            streetViewControl: false,
            navigationControlOptions: {
                style: google.maps.NavigationControlStyle.SMALL
            },
            mapTypeControl: false,
            scaleControl:true
        };

        KmlBrowserLight.map = new google.maps.Map($("map_canvas"), mapOptions);
        // pEChE
        KmlBrowserLight.infoWindow = new google.maps.InfoWindow({
                maxWidth:700
        });
        google.maps.event.addListener(KmlBrowserLight.map, "click", function() {
            KmlBrowserLight.infoWindow.close();        
        });
        
//        GMapMarkerManager.SUPERVISOR = new MarkerManager(GMap.mapObj);
        
        google.maps.event.addListener(KmlBrowserLight.map, "center_changed", function() {
        	var latLng = KmlBrowserLight.map.getCenter();
        	KmlBrowserLight.setCookie("lat",latLng.lat());
        	KmlBrowserLight.setCookie("lng",latLng.lng());
        });
        
        google.maps.event.addListener(KmlBrowserLight.map ,"zoom_changed", function() {
        	KmlBrowserLight.setCookie("zoom",KmlBrowserLight.map.getZoom());
        });
        
		KmlBrowserLight.showMessage("f[^ǂݍݒ...\n΂炭܂");
		// KmlBrowserLight.loadKmlData();
		
		var dataUrl = "http://maps.google.co.jp/maps/ms?msa=0&msid=" +
			KmlBrowserLight.MAP_ID + "&ie=UTF8&authuser=0&output=kml";
		var georssLayer = new google.maps.KmlLayer(
			dataUrl,
			{preserveViewport:true}
			);
        
        google.maps.event.addListener(georssLayer ,"metadata_changed", function() {
        	    var metadata = georssLayer.getMetadata();
                document.title = metadata.name + " - KML Browser";
                var titleMain = new Element("span", {});
                var orgUrl  = "http://maps.google.co.jp/maps/ms?msa=0&msid=" + KmlBrowserLight.MAP_ID;
			    var orgLink = new Element("a", {href:orgUrl});
                orgLink.innerHTML="IWi}bv͂";
                
                titleMain.innerHTML = metadata.name.escapeHTML() + "&nbsp;&nbsp;&nbsp;";
                $("descriptionTitle").insert(titleMain);
                $("descriptionTitle").insert(orgLink);
                $("descriptionText").innerHTML = metadata.description.escapeHTML().replace(/\n/g,"<br>");
                KmlBrowserLight.showDescription();
                KmlBrowserLight.hideMessage();
        });
        
        georssLayer.setMap(KmlBrowserLight.map);
	}
	,
	descriptionReady:false
	,
	descriptionHidden:false
	,
	showDescription:function() {
		$("description").style.display = "block";
	    new Effect.Opacity("description", {from : 0.0, to : 0.99999, duration: 1.0, afterFinish:function() {
		    $("description").style.display = "block";
		    setTimeout(KmlBrowserLight.autoHideDescription, 3000);
	    }});
		
	}
	,
	autoHideDescription:function() {
	    KmlBrowserLight.descriptionReady = true;
		KmlBrowserLight.controller.toggleContent();
	}
	,
	getClientSize:function() {
		var width = 0;
		var height = 0;
		
        // IE6Ή
        if (KmlBrowserLight.IS_IE) {
            width = document.documentElement.clientWidth;
            height = document.documentElement.clientHeight;
        } else {
        	width = window.innerWidth;
        	height = window.innerHeight;
        	
        }
        return {"width":width, "height":height};
	}
	,
	bind:function(target, func) {
		return function() { func.apply(target); };
	}
	,
	debug:function(str) {
		if (!KmlBrowserLight.DEBUG_MODE) return;
		if (KmlBrowserLight.DEBUG_LOGGER === null) return;
		if (!KmlBrowserLight.DEBUG_LOGGER) {
			if (!window.console) {
				KmlBrowserLight.DEBUG_LOGGER = null;
				return;
			}
			if (window.console.log) {
				KmlBrowserLight.DEBUG_LOGGER = true;
			} else {
				KmlBrowserLight.DEBUG_LOGGER = null;
				return;
			}
		}
		window.console.log(str);
	}
	,
	cookieManager:new CookieManager()
};
KmlBrowserLight.DescriptionPane.prototype.resize = function() {
	var clientSize = KmlBrowserLight.getClientSize();
	this.divContainer.style.height = (clientSize.height - 50) + "px";
	this.divHeader.style.height    = "22px";
	this.divBody.style.height      = (clientSize.height - 72) + "px";
};
KmlBrowserLight.DescriptionPane.prototype.toggleContent = function() {
	if  (!KmlBrowserLight.descriptionReady) return;
	var bodyName = "descriptionBody";
	var divCon   = $("description");
	if (KmlBrowserLight.descriptionHidden) {
	    new Effect.Opacity(bodyName, {from : 0, to : 0.93, duration: 1.0, 
	    	afterFinish:function() {
	            KmlBrowserLight.descriptionReady = true;
	            KmlBrowserLight.descriptionHidden = false;
	       },
	       beforeStart:function() {
	       	    KmlBrowserLight.descriptionReady = false;
	            $(bodyName).style.display = "block";
	            KmlBrowserLight.controller.resize();
	       }
	    });
		
	} else {
	    new Effect.Opacity(bodyName, {from : 0.93, to : 0.0, duration: 1.0, 
	    	afterFinish:function() {
	            KmlBrowserLight.descriptionReady = true;
	            $(bodyName).style.display = "none";
	            divCon.style.height = "22px";
	            KmlBrowserLight.descriptionHidden = true;
	       },
	       beforeStart:function() {
	       	    KmlBrowserLight.descriptionReady = false;
	       }
	    });
		
	}
	
};

(function() {
	// uEU`FbN
    var ua = navigator.userAgent;
    var isOpera = Object.prototype.toString.call(window.opera) == '[object Opera]';
    var isIE  = !!window.attachEvent && !isOpera;
    if (isIE) {
    	KmlBrowserLight.IS_IE = true;
    	/***
        var ieMajVer = ua.match(/MSIE (\d+)/);
        if (ieMajVer.length > 1) {
            var majVer = ieMajVer[1];
            KmlBrowserLight.IS_IE = (majVer <= 6);
        } ***/
    }
    // Cxgnhݒ
    // window (body) onload
    Event.observe(window, "load", KmlBrowserLight.onLoad, false);
    Event.observe(window, "resize", function(){ KmlBrowserLight.controller.resize(); }, false);
})();

